<?php
/*
 * Mboard Action Plugin.
 *
 * @license  Apache 2 (http://www.apache.org/licenses/LICENSE-2.0)
 * @author   Kazuyuki Matsuda / kazm.atmark.shorindo.com
 */

class action_plugin_mboard extends DokuWiki_Action_Plugin {

	function getInfo() {
        return confToHash(dirname(__FILE__).'/plugin.info.txt');
	}

	function register(&$controller) {
        $controller->register_hook('AJAX_CALL_UNKNOWN',
                                   'BEFORE', $this, 'do_ajax');
        $controller->register_hook('DATASOURCE_UNKNOWN_SCHEMA',
                                   'BEFORE', $this, 'do_datasource');
	}

    function do_ajax(&$event) {
        if ($event->data == 'mboard') {
            header('Content-Type: text/html; charset=UTF-8');
            $event->preventDefault();
            $event->stopPropagation();
            $helper = $this->helper = plugin_load('helper', 'mboard');
            $id = $_POST['id'];
            $pageid = preg_replace('/^.*#/', '', $id);
            $page = $_POST['page'];
            $meta = $helper->getmeta($id);
            $form = array('user' => $helper->get_session('user'));

            switch ($_REQUEST['cmd']) {
            case 'add':
                if ($helper->checkacl($id) < AUTH_EDIT)
                    return $this->nopermission();
                if ($_POST['token'] != md5(session_id()))
                    return $this->error('invalidaccess');
                $result = $helper->add_message($id, $_POST['user'], $_POST['mail'], $_POST['text']);
                if ($result) {
                    $helper->set_session('user', $form['user'] = $_POST['user']);
                    $this->hilit($id, $result['MESSAGE_ID']);
                } else {
                    $form = array('user' => $_POST['user'],
                                  'mail' => $_POST['mail'],
                                  'text' => $_POST['text']);
                    $message = '<div class="error">';
                    foreach ($helper->errors as $e) {
                        foreach ($e as $m) {
                            $message .= $m."<br/>";
                        }
                    }
                    $message .= '</div>';
                }
                break;

            case 'remove':
                if ($helper->checkacl($id, $_POST['num']) < AUTH_DELETE)
                    return $this->nopermission();
                $result = $helper->remove_message($id, $_POST['num']);
                break;
            }

            if ($helper->checkacl($id) < AUTH_READ)
                return $this->nopermission();
            if ($meta['sort'] == 'desc') {
                print $message;
                print $helper->html_form($id, $form);
                print $helper->html_list($id, $page);
                print $helper->html_index($id, $page);
            } else {
                print $helper->html_list($id, $page);
                print $helper->html_index($id, $page);
                print $message;
                print $helper->html_form($id, $form);
            }
        }
    }

    /**
     * Write http 403 Forbidden.
     */
    function nopermission() {
        header('HTTP/1.0 403 Forbidden', FALSE);
        print $this->getLang('nopermission');
    }

    /**
     * Hilit message after message posted.
     */
    function hilit($id, $num) {
        list($pageid, $boardid) = explode('#', $id);
        print <<<EOF
<style type="text/css">
dt#mboard_head_{$boardid}_{$num} { background-color: #FFFFAA; }
dd#mboard_body_{$boardid}_{$num} { background-color: #FFFFAA; }
</style>
EOF;
    }

    /**
     * Write error message.
     */
    function error($key) {
        print $this->getLang($key);
    }

    /**
     * Handle DATASOURCE_UNKNOWN_SCHEMA.
     * dsn syntax: mboard:thread?id=notice&size=5&sort=desc&page=1
     */
    function do_datasource(&$evt) {
        //dbglog("action_plugin_mboard:do_datasource(".print_r($evt,true).")");
        if (preg_match('/^mboard:(.*)$/', $evt->data['dsn'], $m)) {
            $evt->data['result'] = $this->execute($evt->data['dsn']);
            return true;
        } else {
            return false;
        }
    }

    function execute($dsn) {
        if (preg_match('/^mboard:thread\?(.*)$/', $dsn, $m)) {
            $params = array();
            foreach (explode('&', $m[1]) as $o) {
                list($key, $val) = explode('=', $o);
                $params[$key] = $val;
            }
            $helper = plugin_load('helper', 'mboard');
            $result = $helper->xml_list($params);
            return $result;
        }
    }
}
