<?php
/**
 * Mboard Admin Plugin.
 *
 * @license  Apache 2 (http://www.apache.org/licenses/LICENSE-2.0)
 * @author   Kazuyuki Matsuda / kazm.atmark.shorindo.com
 */
if (!defined('DOKU_LF')) define('DOKU_LF', "\n");
if (!defined('DOKU_TAB')) define('DOKU_TAB', "\t");
if (!defined('DOKU_INC')) define('DOKU_INC',realpath(dirname(__FILE__).'/../../').'/');
if (!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN',DOKU_INC.'lib/plugins/');
require_once(DOKU_PLUGIN.'admin.php');

class admin_plugin_mboard extends DokuWiki_Admin_Plugin {
    var $conn;

    function getInfo() {
        return confToHash(dirname(__FILE__).'/plugin.info.txt');
    }

    function handle() {
    }

    function html() {
        $datasource = plugin_load('helper', 'datasource');
        if (!is_object($datasource)) {
            print $this->getlang('no_datasource');
            return;
        }

        $this->conn = $datasource->connect();
        if (!is_object($this->conn)) {
            print $this->getlang('cant_connect');
            return;
        }

        /*
        $this->conn = new PDO($this->getConf('dsn'),
                       $this->getConf('dbuser'),
                       conf_decodeString($this->getConf('dbpass')));
        if (!is_object($this->conn)) {
            print $this->getlang('cant_connect');
            return;
        }
        */

        //check table exists
        $dbprefix = $this->getConf('dbprefix');
        $sql = "SELECT COUNT(*) FROM {$dbprefix}MBOARD";
        $stmt = $this->conn->prepare($sql);
        $stmt->execute();
        if ($stmt->errorCode() != '00000') {
            print $this->getlang('table_not_exists');
            $sql = <<<EOF
CREATE TABLE {$dbprefix}MBOARD (
	BOARD_ID	VARCHAR(256),
	MESSAGE_ID	INTEGER,
	MESSAGE_USER	VARCHAR(80),
	MESSAGE_MAIL	VARCHAR(80),
	MESSAGE_TEXT	TEXT,
	MESSAGE_DATE	DATETIME,
	USER_IP		VARCHAR(16),
	USER_ID		VARCHAR(80),
	STATUS		INTEGER DEFAULT 0,
	PRIMARY KEY (BOARD_ID, MESSAGE_ID)
)
EOF;
            $stmt = $this->conn->query($sql);
            if ($stmt->errorCode() != '00000') {
                print $this->getlang('table_cannot_create');
                print_r($stmt->errorInfo(), false);
            } else {
                print $this->getlang('table_created');
            }
        } else {
            print $this->getlang('table_exists');
        }
    }

    function getMenuText($lang) {
        return $this->getLang('menu_description');
    }

    function _find_table() {
    }

    function _create_table() {
    }
}
